#! /usr/bin/perl
#
# pmfingerd.pl	This script can be installed on any Linux libc5
#		terminal server as finger daemon. It will give a list
#		of logged-in users in the Portmaster "show sessions"
#		format. Users logged in on a virtual console and through
#		pty's are not listed.
#
# Version:	@(#)pmfingerd.pl  1.00  06-Jun-1997  miquels@cistron.nl
#

# Size of utmp structure on your system.
$utmpsize = 56;

# Location of utmp file.
$utmpfile = '/var/run/utmp';

# Base IP address.
$baseip = "195.64";

# Pose as finger daemon.
if ($0 =~ m/fingerd/) {
	$args = <STDIN>;
}

#
#	Unpack UTMP file, and return an array consisting of:
#
#	0. ut_type
#	1. ut_pid
#	2. ut_line
#	3. ut_id
#	4. ut_time
#	5. ut_user
#	6. ut_host
#
sub unpackutmp {
	my @tmp;
	my ($la);

	@tmp = unpack("S S i a12 a4 i a8 a16", $_[0]);
	$la = shift @tmp;
	shift @tmp;
	unshift @tmp, $la;
	for($i = 0; $i <= 6; $i++) {
		$tmp[$i] =~ s/\0.*$//;
	}
	@tmp;
}

unless (open(FD, "$utmpfile")) {
	print STDERR "$utmpfile: $!\n";
	exit(1);
}

print <<EOF;
Port User            Host/Inet/Dest   Type    Dir Status         Start   Idle
---- --------------- ---------------- ------- --- ------------- ------ ------
EOF

$now = time;

while (read(FD, $ut, $utmpsize)) {

	@array = &unpackutmp($ut);
	next if ($array[0] != 7);
	next if ($array[2] =~ m/^tty[0-9p-z]/);

	($port,$adr) = split(/:/, $array[6]);
	$array[5] =~ s/\s+$//;
	if ($adr eq '') {
		$type = "Login";
	} else {
		$adr =~ s/^x/$baseip/;
		$type = 'Netwrk';
	}
	$tm = ($now - $array[4]) / 60;
	printf("S%-3d %-15.15s %-16.16s %-7.7s In  ESTABLISHED   %6d %6d\n",
		$port, $array[5], $adr, $type, $tm, 0);
}
close FD;

